--- /tmp/Perl6-Perldoc-v0.0.5/lib/Perl6/Perldoc/To/Xhtml.pm	Wed Apr 25 07:31:02 2007
+++ Xhtml.pm	Thu Apr 26 20:45:08 2007
@@ -19,6 +19,11 @@
     1            => '-//W3C//DTD XHTML 1.0 Transitional//EN',
 );
 
+my %DTD_URLS = (
+    strict       => 'http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd',
+    transitional => 'http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd'
+);
+
 sub _full_doc {
     my ($tree, $opt_ref, $body) = @_;
 
@@ -48,10 +53,16 @@
              :                                $requested
              ;
 
+    # Determine the DTD's URL
+    my $url =  !defined $requested          ? $DTD_URLS{transitional}
+             : exists $DTD_URLS{$requested} ? $DTD_URLS{$requested}
+             :                                $requested
+             ;
+
     # Encapsulate body in appropriate frou-frou...
     return <<END_STRICT_DOC;
-<!DOCTYPE html PUBLIC "$type">
-<html>
+<!DOCTYPE html PUBLIC "$type" "$url">
+<html xmlns="http://www.w3.org/1999/xhtml">
 <head>
 <title>$title</title>
 $style
